/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.kaki.client.gui;

import java.awt.BorderLayout;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.eof.EOConvention;
import org.cocktail.application.client.eof.EOLolfNomenclatureDepense;
import org.cocktail.application.client.eof.EOOrgan;
import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.kaki.client.metier.EOCodeAnalytique;
import org.cocktail.kaki.client.metier.EOMois;
import org.cocktail.kaki.client.metier.EOPafReversements;
import org.cocktail.kaki.client.metier.EOPlanComptableExer;
import org.cocktail.kaki.common.KakiConstantes;
import org.cocktail.kaki.common.KakiIcones;

import com.webobjects.eointerface.EODisplayGroup;

/**
 * 
 * @author cpinsard
 */
public class ReversementsView extends javax.swing.JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6321789761362845292L;


	protected EODisplayGroup eod;
	protected ZEOTable myEOTable;


	protected ZEOTableModel myTableModel;
	protected TableSorter myTableSorter;

	/** Creates new form TemplateJPanel */
	public ReversementsView(EODisplayGroup displayGroup) {

		eod = displayGroup;

		initComponents();
		initGui();

	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */

	// <editor-fold defaultstate="collapsed"
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        tfTotal = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        viewTable = new javax.swing.JPanel();
        buttonTraiter = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        tfVentilation = new javax.swing.JTextField();
        buttonGetClasse4 = new javax.swing.JButton();
        tfLbud = new javax.swing.JTextField();
        buttonGetLbud = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        btnPrint = new javax.swing.JButton();
        tfImputation = new javax.swing.JTextField();
        buttonGetClasse6 = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        btnSupprimer = new javax.swing.JButton();

        tfTotal.setEditable(false);
        tfTotal.setHorizontalAlignment(javax.swing.JTextField.RIGHT);

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("Total");

        viewTable.setLayout(new java.awt.BorderLayout());

        buttonTraiter.setText("Traiter Reversements");
        buttonTraiter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonTraiterActionPerformed(evt);
            }
        });

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel3.setText("Ventilation");

        tfVentilation.setBackground(new java.awt.Color(204, 204, 204));
        tfVentilation.setEditable(false);

        buttonGetClasse4.setMaximumSize(new java.awt.Dimension(75, 75));
        buttonGetClasse4.setMinimumSize(new java.awt.Dimension(30, 22));

        tfLbud.setBackground(new java.awt.Color(204, 204, 204));
        tfLbud.setEditable(false);

        buttonGetLbud.setMaximumSize(new java.awt.Dimension(75, 75));
        buttonGetLbud.setMinimumSize(new java.awt.Dimension(30, 22));

        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel4.setText("Budget");

        btnPrint.setText("Imprimer");
        btnPrint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnPrintActionPerformed(evt);
            }
        });

        tfImputation.setBackground(new java.awt.Color(204, 204, 204));
        tfImputation.setEditable(false);

        buttonGetClasse6.setMaximumSize(new java.awt.Dimension(75, 75));
        buttonGetClasse6.setMinimumSize(new java.awt.Dimension(30, 22));

        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel5.setText("Imputation");

        btnSupprimer.setMaximumSize(new java.awt.Dimension(75, 75));
        btnSupprimer.setMinimumSize(new java.awt.Dimension(30, 22));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 70, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(tfVentilation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 485, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonGetClasse4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 70, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(tfLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 309, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(buttonGetLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 155, Short.MAX_VALUE)
                                .add(btnPrint, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 112, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(layout.createSequentialGroup()
                                .add(jLabel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 70, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(tfImputation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 485, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(buttonGetClasse6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                .add(jLabel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 81, Short.MAX_VALUE)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(buttonTraiter)
                            .add(tfTotal, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 139, Short.MAX_VALUE)))
                    .add(layout.createSequentialGroup()
                        .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 795, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(btnSupprimer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 414, Short.MAX_VALUE)
                    .add(btnSupprimer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel5)
                            .add(tfImputation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(buttonGetClasse6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel3)
                            .add(tfVentilation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(buttonGetClasse4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(jLabel2)
                        .add(tfTotal, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(buttonTraiter)
                    .add(jLabel4)
                    .add(tfLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(buttonGetLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnPrint))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

	private void buttonTraiterActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_buttonTraiterActionPerformed
		// TODO add your handling code here:
	}// GEN-LAST:event_buttonTraiterActionPerformed

	private void btnPrintActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_btnPrintActionPerformed
		// TODO add your handling code here:
	}// GEN-LAST:event_btnPrintActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JButton btnPrint;
    protected javax.swing.JButton btnSupprimer;
    protected javax.swing.JButton buttonGetClasse4;
    protected javax.swing.JButton buttonGetClasse6;
    protected javax.swing.JButton buttonGetLbud;
    protected javax.swing.JButton buttonTraiter;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    protected javax.swing.JTextField tfImputation;
    protected javax.swing.JTextField tfLbud;
    private javax.swing.JTextField tfTotal;
    protected javax.swing.JTextField tfVentilation;
    protected javax.swing.JPanel viewTable;
    // End of variables declaration//GEN-END:variables

	/**
     * 
     */
	private void initGui() {

		buttonGetClasse4.setIcon(KakiIcones.ICON_SELECT_16);
		buttonGetClasse6.setIcon(KakiIcones.ICON_SELECT_16);
		buttonGetLbud.setIcon(KakiIcones.ICON_SELECT_16);

		buttonTraiter.setIcon(KakiIcones.ICON_CALCULATE_16);
		btnSupprimer.setIcon(KakiIcones.ICON_DELETE);

		btnPrint.setIcon(KakiIcones.ICON_PRINTER_16);

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

		ZEOTableModelColumn col = new ZEOTableModelColumn(eod, EOPafReversements.TO_MOIS_KEY + "." + EOMois.MOIS_NUMERO_KEY, "Mois",40);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafReversements.ORGAN_KEY + "." + EOOrgan.ORG_UB_KEY, "UB", 50);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafReversements.ORGAN_KEY + "." + EOOrgan.ORG_CR_KEY, "CR", 50);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafReversements.ORGAN_KEY + "." + EOOrgan.ORG_SOUSCR_KEY, "SOUS CR", 50);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafReversements.LOLF_KEY + "." + EOLolfNomenclatureDepense.LOLF_CODE_KEY, "LOLF", 50);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafReversements.CANAL_KEY + "." + EOCodeAnalytique.CAN_CODE_KEY, "CANAL", 50);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafReversements.CONVENTION_KEY + "." + EOConvention.CON_INDEX_KEY, "CONV", 50);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafReversements.PLAN_COMPTABLE_KEY + "." + EOPlanComptableExer.PCO_NUM_KEY, "COMPTE", 50);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafReversements.CONTREPARTIE_KEY + "." + EOPlanComptableExer.PCO_NUM_KEY,	"CONTREPARTIE", 50);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafReversements.PLAN_COMPTABLE_KEY + "." + EOPlanComptableExer.PCO_LIBELLE_KEY, "LIBELLE", 140);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafReversements.REV_MONTANT_KEY, "Montant", 60);
		// col.setFormatDisplay(CocktailConstantes.FORMAT_DECIMAL);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOPafReversements.REV_ETAT_KEY, "ETAT", 60);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);

		myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		// myEOTable.addListener(myListenerContrat);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());

		myEOTable.setBackground(KakiConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTable.setSelectionBackground(KakiConstantes.COLOR_SELECTED_ROW);
		myEOTable
				.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		viewTable.setLayout(new BorderLayout());
		viewTable.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
		viewTable.removeAll();
		viewTable.add(new JScrollPane(myEOTable), BorderLayout.CENTER);

	}

	public javax.swing.JTextField getTfTotal() {
		return tfTotal;
	}

	public void setTfTotal(javax.swing.JTextField tfTotal) {
		this.tfTotal = tfTotal;
	}

	public javax.swing.JButton getBtnSupprimer() {
		return btnSupprimer;
	}

	public void setBtnSupprimer(javax.swing.JButton btnSupprimer) {
		this.btnSupprimer = btnSupprimer;
	}
	public javax.swing.JButton getButtonGetClasse4() {
		return buttonGetClasse4;
	}

	public void setButtonGetClasse4(javax.swing.JButton buttonGetClasse4) {
		this.buttonGetClasse4 = buttonGetClasse4;
	}

	public javax.swing.JTextField getTfVentilation() {
		return tfVentilation;
	}

	public void setTfVentilation(javax.swing.JTextField tfVentilation) {
		this.tfVentilation = tfVentilation;
	}

	public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public javax.swing.JButton getButtonGetLbud() {
		return buttonGetLbud;
	}

	public javax.swing.JButton getButtonGetClasse6() {
		return buttonGetClasse6;
	}

	public javax.swing.JTextField getTfImputation() {
		return tfImputation;
	}

	public void setTfImputation(javax.swing.JTextField tfImputation) {
		this.tfImputation = tfImputation;
	}

	public void setButtonGetClasse6(javax.swing.JButton buttonGetClasse6) {
		this.buttonGetClasse6 = buttonGetClasse6;
	}

	public javax.swing.JButton getBtnPrint() {
		return btnPrint;
	}

	public void setBtnPrint(javax.swing.JButton btnPrint) {
		this.btnPrint = btnPrint;
	}

	public void setButtonGetLbud(javax.swing.JButton buttonGetLbud) {
		this.buttonGetLbud = buttonGetLbud;
	}

	public javax.swing.JTextField getTfLbud() {
		return tfLbud;
	}

	public void setTfLbud(javax.swing.JTextField tfLbud) {
		this.tfLbud = tfLbud;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}
	public javax.swing.JButton getButtonTraiter() {
		return buttonTraiter;
	}

	public void setButtonTraiter(javax.swing.JButton buttonTraiter) {
		this.buttonTraiter = buttonTraiter;
	}

}
